unit schCitasClient_Intf;

interface

uses
  Classes, DB, SysUtils, uROClasses, uDADataTable;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_CITAS = '{8A00AC3C-FD7C-4241-B7C7-8EFD1937F000}';
  RID_VENDEDORES = '{59850C69-DF4D-44E2-BA00-C4FDC03E39E0}';

  { Data table names }
  nme_CITAS = 'CITAS';
  nme_VENDEDORES = 'VENDEDORES';

  { CITAS fields }
  fld_CITASID = 'ID';
  fld_CITASPARENTID = 'PARENTID';
  fld_CITASSTART = 'START';
  fld_CITASTIPO = 'TIPO';
  fld_CITASFINISH = 'FINISH';
  fld_CITASOPTIONS = 'OPTIONS';
  fld_CITASCAPTION = 'CAPTION';
  fld_CITASMENSAJE = 'MENSAJE';
  fld_CITASRECURRENCEINDEX = 'RECURRENCEINDEX';
  fld_CITASRESOURCEID = 'RESOURCEID';
  fld_CITASLOCATION = 'LOCATION';
  fld_CITASREMINDER = 'REMINDER';
  fld_CITASSTATE = 'STATE';
  fld_CITASLABELCOLOR = 'LABELCOLOR';
  fld_CITASCODIGOCONTRATO = 'CODIGOCONTRATO';
  fld_CITASTIPOTAREA = 'TIPOTAREA';
  fld_CITASNOMBRECLIENTE = 'NOMBRECLIENTE';
  fld_CITASPARTIDA = 'PARTIDA';
  fld_CITASCOMPLETADA = 'COMPLETADA';
  fld_CITASNOMBREPROVEEDOR = 'NOMBREPROVEEDOR';
  fld_CITASCODIGOCOLUMNA = 'CODIGOCOLUMNA';
  fld_CITASCODIGOFILA = 'CODIGOFILA';
  fld_CITASEMPRESA = 'EMPRESA';

  { CITAS field indexes }
  idx_CITASID = 0;
  idx_CITASPARENTID = 1;
  idx_CITASSTART = 2;
  idx_CITASTIPO = 3;
  idx_CITASFINISH = 4;
  idx_CITASOPTIONS = 5;
  idx_CITASCAPTION = 6;
  idx_CITASMENSAJE = 7;
  idx_CITASRECURRENCEINDEX = 8;
  idx_CITASRESOURCEID = 9;
  idx_CITASLOCATION = 10;
  idx_CITASREMINDER = 11;
  idx_CITASSTATE = 12;
  idx_CITASLABELCOLOR = 13;
  idx_CITASCODIGOCONTRATO = 14;
  idx_CITASTIPOTAREA = 15;
  idx_CITASNOMBRECLIENTE = 16;
  idx_CITASPARTIDA = 17;
  idx_CITASCOMPLETADA = 18;
  idx_CITASNOMBREPROVEEDOR = 19;
  idx_CITASCODIGOCOLUMNA = 20;
  idx_CITASCODIGOFILA = 21;
  idx_CITASEMPRESA = 22;

  { VENDEDORES fields }
  fld_VENDEDORESCODIGOEMPRESA = 'CODIGOEMPRESA';
  fld_VENDEDORESCODIGO = 'CODIGO';
  fld_VENDEDORESFECHAALTA = 'FECHAALTA';
  fld_VENDEDORESUSUARIO = 'USUARIO';
  fld_VENDEDORESNIFCIF = 'NIFCIF';
  fld_VENDEDORESNOMBRE = 'NOMBRE';
  fld_VENDEDORESNOTAS = 'NOTAS';
  fld_VENDEDORESCALLE = 'CALLE';
  fld_VENDEDORESPROVINCIA = 'PROVINCIA';
  fld_VENDEDORESCODIGOPOSTAL = 'CODIGOPOSTAL';
  fld_VENDEDORESPOBLACION = 'POBLACION';
  fld_VENDEDORESTELEFONO1 = 'TELEFONO1';
  fld_VENDEDORESTELEFONO2 = 'TELEFONO2';
  fld_VENDEDORESMOVIL = 'MOVIL';
  fld_VENDEDORESFAX = 'FAX';
  fld_VENDEDORESCORREO1 = 'CORREO1';
  fld_VENDEDORESCORREO2 = 'CORREO2';
  fld_VENDEDORESPAGINAWEB = 'PAGINAWEB';
  fld_VENDEDORESPERSONACONTACTO = 'PERSONACONTACTO';

  { VENDEDORES field indexes }
  idx_VENDEDORESCODIGOEMPRESA = 0;
  idx_VENDEDORESCODIGO = 1;
  idx_VENDEDORESFECHAALTA = 2;
  idx_VENDEDORESUSUARIO = 3;
  idx_VENDEDORESNIFCIF = 4;
  idx_VENDEDORESNOMBRE = 5;
  idx_VENDEDORESNOTAS = 6;
  idx_VENDEDORESCALLE = 7;
  idx_VENDEDORESPROVINCIA = 8;
  idx_VENDEDORESCODIGOPOSTAL = 9;
  idx_VENDEDORESPOBLACION = 10;
  idx_VENDEDORESTELEFONO1 = 11;
  idx_VENDEDORESTELEFONO2 = 12;
  idx_VENDEDORESMOVIL = 13;
  idx_VENDEDORESFAX = 14;
  idx_VENDEDORESCORREO1 = 15;
  idx_VENDEDORESCORREO2 = 16;
  idx_VENDEDORESPAGINAWEB = 17;
  idx_VENDEDORESPERSONACONTACTO = 18;

type
  { ICITAS }
  ICITAS = interface(IDAStronglyTypedDataTable)
  ['{03AC3728-729B-4224-B900-4A4A1666746B}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetPARENTIDValue: Integer;
    procedure SetPARENTIDValue(const aValue: Integer);
    function GetSTARTValue: DateTime;
    procedure SetSTARTValue(const aValue: DateTime);
    function GetTIPOValue: Integer;
    procedure SetTIPOValue(const aValue: Integer);
    function GetFINISHValue: DateTime;
    procedure SetFINISHValue(const aValue: DateTime);
    function GetOPTIONSValue: Integer;
    procedure SetOPTIONSValue(const aValue: Integer);
    function GetCAPTIONValue: String;
    procedure SetCAPTIONValue(const aValue: String);
    function GetMENSAJEValue: String;
    procedure SetMENSAJEValue(const aValue: String);
    function GetRECURRENCEINDEXValue: Integer;
    procedure SetRECURRENCEINDEXValue(const aValue: Integer);
    function GetRESOURCEIDValue: Integer;
    procedure SetRESOURCEIDValue(const aValue: Integer);
    function GetLOCATIONValue: String;
    procedure SetLOCATIONValue(const aValue: String);
    function GetREMINDERValue: Integer;
    procedure SetREMINDERValue(const aValue: Integer);
    function GetSTATEValue: Integer;
    procedure SetSTATEValue(const aValue: Integer);
    function GetLABELCOLORValue: Integer;
    procedure SetLABELCOLORValue(const aValue: Integer);
    function GetCODIGOCONTRATOValue: String;
    procedure SetCODIGOCONTRATOValue(const aValue: String);
    function GetTIPOTAREAValue: String;
    procedure SetTIPOTAREAValue(const aValue: String);
    function GetNOMBRECLIENTEValue: String;
    procedure SetNOMBRECLIENTEValue(const aValue: String);
    function GetPARTIDAValue: String;
    procedure SetPARTIDAValue(const aValue: String);
    function GetCOMPLETADAValue: DateTime;
    procedure SetCOMPLETADAValue(const aValue: DateTime);
    function GetNOMBREPROVEEDORValue: String;
    procedure SetNOMBREPROVEEDORValue(const aValue: String);
    function GetCODIGOCOLUMNAValue: Integer;
    procedure SetCODIGOCOLUMNAValue(const aValue: Integer);
    function GetCODIGOFILAValue: Integer;
    procedure SetCODIGOFILAValue(const aValue: Integer);
    function GetEMPRESAValue: Integer;
    procedure SetEMPRESAValue(const aValue: Integer);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property PARENTID: Integer read GetPARENTIDValue write SetPARENTIDValue;
    property START: DateTime read GetSTARTValue write SetSTARTValue;
    property TIPO: Integer read GetTIPOValue write SetTIPOValue;
    property FINISH: DateTime read GetFINISHValue write SetFINISHValue;
    property OPTIONS: Integer read GetOPTIONSValue write SetOPTIONSValue;
    property CAPTION: String read GetCAPTIONValue write SetCAPTIONValue;
    property MENSAJE: String read GetMENSAJEValue write SetMENSAJEValue;
    property RECURRENCEINDEX: Integer read GetRECURRENCEINDEXValue write SetRECURRENCEINDEXValue;
    property RESOURCEID: Integer read GetRESOURCEIDValue write SetRESOURCEIDValue;
    property LOCATION: String read GetLOCATIONValue write SetLOCATIONValue;
    property REMINDER: Integer read GetREMINDERValue write SetREMINDERValue;
    property STATE: Integer read GetSTATEValue write SetSTATEValue;
    property LABELCOLOR: Integer read GetLABELCOLORValue write SetLABELCOLORValue;
    property CODIGOCONTRATO: String read GetCODIGOCONTRATOValue write SetCODIGOCONTRATOValue;
    property TIPOTAREA: String read GetTIPOTAREAValue write SetTIPOTAREAValue;
    property NOMBRECLIENTE: String read GetNOMBRECLIENTEValue write SetNOMBRECLIENTEValue;
    property PARTIDA: String read GetPARTIDAValue write SetPARTIDAValue;
    property COMPLETADA: DateTime read GetCOMPLETADAValue write SetCOMPLETADAValue;
    property NOMBREPROVEEDOR: String read GetNOMBREPROVEEDORValue write SetNOMBREPROVEEDORValue;
    property CODIGOCOLUMNA: Integer read GetCODIGOCOLUMNAValue write SetCODIGOCOLUMNAValue;
    property CODIGOFILA: Integer read GetCODIGOFILAValue write SetCODIGOFILAValue;
    property EMPRESA: Integer read GetEMPRESAValue write SetEMPRESAValue;
  end;

  { TCITASDataTableRules }
  TCITASDataTableRules = class(TDADataTableRules, ICITAS)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetPARENTIDValue: Integer; virtual;
    procedure SetPARENTIDValue(const aValue: Integer); virtual;
    function GetSTARTValue: DateTime; virtual;
    procedure SetSTARTValue(const aValue: DateTime); virtual;
    function GetTIPOValue: Integer; virtual;
    procedure SetTIPOValue(const aValue: Integer); virtual;
    function GetFINISHValue: DateTime; virtual;
    procedure SetFINISHValue(const aValue: DateTime); virtual;
    function GetOPTIONSValue: Integer; virtual;
    procedure SetOPTIONSValue(const aValue: Integer); virtual;
    function GetCAPTIONValue: String; virtual;
    procedure SetCAPTIONValue(const aValue: String); virtual;
    function GetMENSAJEValue: String; virtual;
    procedure SetMENSAJEValue(const aValue: String); virtual;
    function GetRECURRENCEINDEXValue: Integer; virtual;
    procedure SetRECURRENCEINDEXValue(const aValue: Integer); virtual;
    function GetRESOURCEIDValue: Integer; virtual;
    procedure SetRESOURCEIDValue(const aValue: Integer); virtual;
    function GetLOCATIONValue: String; virtual;
    procedure SetLOCATIONValue(const aValue: String); virtual;
    function GetREMINDERValue: Integer; virtual;
    procedure SetREMINDERValue(const aValue: Integer); virtual;
    function GetSTATEValue: Integer; virtual;
    procedure SetSTATEValue(const aValue: Integer); virtual;
    function GetLABELCOLORValue: Integer; virtual;
    procedure SetLABELCOLORValue(const aValue: Integer); virtual;
    function GetCODIGOCONTRATOValue: String; virtual;
    procedure SetCODIGOCONTRATOValue(const aValue: String); virtual;
    function GetTIPOTAREAValue: String; virtual;
    procedure SetTIPOTAREAValue(const aValue: String); virtual;
    function GetNOMBRECLIENTEValue: String; virtual;
    procedure SetNOMBRECLIENTEValue(const aValue: String); virtual;
    function GetPARTIDAValue: String; virtual;
    procedure SetPARTIDAValue(const aValue: String); virtual;
    function GetCOMPLETADAValue: DateTime; virtual;
    procedure SetCOMPLETADAValue(const aValue: DateTime); virtual;
    function GetNOMBREPROVEEDORValue: String; virtual;
    procedure SetNOMBREPROVEEDORValue(const aValue: String); virtual;
    function GetCODIGOCOLUMNAValue: Integer; virtual;
    procedure SetCODIGOCOLUMNAValue(const aValue: Integer); virtual;
    function GetCODIGOFILAValue: Integer; virtual;
    procedure SetCODIGOFILAValue(const aValue: Integer); virtual;
    function GetEMPRESAValue: Integer; virtual;
    procedure SetEMPRESAValue(const aValue: Integer); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property PARENTID: Integer read GetPARENTIDValue write SetPARENTIDValue;
    property START: DateTime read GetSTARTValue write SetSTARTValue;
    property TIPO: Integer read GetTIPOValue write SetTIPOValue;
    property FINISH: DateTime read GetFINISHValue write SetFINISHValue;
    property OPTIONS: Integer read GetOPTIONSValue write SetOPTIONSValue;
    property CAPTION: String read GetCAPTIONValue write SetCAPTIONValue;
    property MENSAJE: String read GetMENSAJEValue write SetMENSAJEValue;
    property RECURRENCEINDEX: Integer read GetRECURRENCEINDEXValue write SetRECURRENCEINDEXValue;
    property RESOURCEID: Integer read GetRESOURCEIDValue write SetRESOURCEIDValue;
    property LOCATION: String read GetLOCATIONValue write SetLOCATIONValue;
    property REMINDER: Integer read GetREMINDERValue write SetREMINDERValue;
    property STATE: Integer read GetSTATEValue write SetSTATEValue;
    property LABELCOLOR: Integer read GetLABELCOLORValue write SetLABELCOLORValue;
    property CODIGOCONTRATO: String read GetCODIGOCONTRATOValue write SetCODIGOCONTRATOValue;
    property TIPOTAREA: String read GetTIPOTAREAValue write SetTIPOTAREAValue;
    property NOMBRECLIENTE: String read GetNOMBRECLIENTEValue write SetNOMBRECLIENTEValue;
    property PARTIDA: String read GetPARTIDAValue write SetPARTIDAValue;
    property COMPLETADA: DateTime read GetCOMPLETADAValue write SetCOMPLETADAValue;
    property NOMBREPROVEEDOR: String read GetNOMBREPROVEEDORValue write SetNOMBREPROVEEDORValue;
    property CODIGOCOLUMNA: Integer read GetCODIGOCOLUMNAValue write SetCODIGOCOLUMNAValue;
    property CODIGOFILA: Integer read GetCODIGOFILAValue write SetCODIGOFILAValue;
    property EMPRESA: Integer read GetEMPRESAValue write SetEMPRESAValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IVENDEDORES }
  IVENDEDORES = interface(IDAStronglyTypedDataTable)
  ['{97DEA09F-C83C-47D3-8854-74212F62078A}']
    { Property getters and setters }
    function GetCODIGOEMPRESAValue: Integer;
    procedure SetCODIGOEMPRESAValue(const aValue: Integer);
    function GetCODIGOValue: Integer;
    procedure SetCODIGOValue(const aValue: Integer);
    function GetFECHAALTAValue: DateTime;
    procedure SetFECHAALTAValue(const aValue: DateTime);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetNIFCIFValue: String;
    procedure SetNIFCIFValue(const aValue: String);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOTASValue: String;
    procedure SetNOTASValue(const aValue: String);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetCODIGOPOSTALValue: String;
    procedure SetCODIGOPOSTALValue(const aValue: String);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetTELEFONO1Value: String;
    procedure SetTELEFONO1Value(const aValue: String);
    function GetTELEFONO2Value: String;
    procedure SetTELEFONO2Value(const aValue: String);
    function GetMOVILValue: String;
    procedure SetMOVILValue(const aValue: String);
    function GetFAXValue: String;
    procedure SetFAXValue(const aValue: String);
    function GetCORREO1Value: String;
    procedure SetCORREO1Value(const aValue: String);
    function GetCORREO2Value: String;
    procedure SetCORREO2Value(const aValue: String);
    function GetPAGINAWEBValue: String;
    procedure SetPAGINAWEBValue(const aValue: String);
    function GetPERSONACONTACTOValue: String;
    procedure SetPERSONACONTACTOValue(const aValue: String);


    { Properties }
    property CODIGOEMPRESA: Integer read GetCODIGOEMPRESAValue write SetCODIGOEMPRESAValue;
    property CODIGO: Integer read GetCODIGOValue write SetCODIGOValue;
    property FECHAALTA: DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NIFCIF: String read GetNIFCIFValue write SetNIFCIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOTAS: String read GetNOTASValue write SetNOTASValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGOPOSTAL: String read GetCODIGOPOSTALValue write SetCODIGOPOSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property TELEFONO1: String read GetTELEFONO1Value write SetTELEFONO1Value;
    property TELEFONO2: String read GetTELEFONO2Value write SetTELEFONO2Value;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property FAX: String read GetFAXValue write SetFAXValue;
    property CORREO1: String read GetCORREO1Value write SetCORREO1Value;
    property CORREO2: String read GetCORREO2Value write SetCORREO2Value;
    property PAGINAWEB: String read GetPAGINAWEBValue write SetPAGINAWEBValue;
    property PERSONACONTACTO: String read GetPERSONACONTACTOValue write SetPERSONACONTACTOValue;
  end;

  { TVENDEDORESDataTableRules }
  TVENDEDORESDataTableRules = class(TDADataTableRules, IVENDEDORES)
  private
  protected
    { Property getters and setters }
    function GetCODIGOEMPRESAValue: Integer; virtual;
    procedure SetCODIGOEMPRESAValue(const aValue: Integer); virtual;
    function GetCODIGOValue: Integer; virtual;
    procedure SetCODIGOValue(const aValue: Integer); virtual;
    function GetFECHAALTAValue: DateTime; virtual;
    procedure SetFECHAALTAValue(const aValue: DateTime); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetNIFCIFValue: String; virtual;
    procedure SetNIFCIFValue(const aValue: String); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOTASValue: String; virtual;
    procedure SetNOTASValue(const aValue: String); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetCODIGOPOSTALValue: String; virtual;
    procedure SetCODIGOPOSTALValue(const aValue: String); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetTELEFONO1Value: String; virtual;
    procedure SetTELEFONO1Value(const aValue: String); virtual;
    function GetTELEFONO2Value: String; virtual;
    procedure SetTELEFONO2Value(const aValue: String); virtual;
    function GetMOVILValue: String; virtual;
    procedure SetMOVILValue(const aValue: String); virtual;
    function GetFAXValue: String; virtual;
    procedure SetFAXValue(const aValue: String); virtual;
    function GetCORREO1Value: String; virtual;
    procedure SetCORREO1Value(const aValue: String); virtual;
    function GetCORREO2Value: String; virtual;
    procedure SetCORREO2Value(const aValue: String); virtual;
    function GetPAGINAWEBValue: String; virtual;
    procedure SetPAGINAWEBValue(const aValue: String); virtual;
    function GetPERSONACONTACTOValue: String; virtual;
    procedure SetPERSONACONTACTOValue(const aValue: String); virtual;

    { Properties }
    property CODIGOEMPRESA: Integer read GetCODIGOEMPRESAValue write SetCODIGOEMPRESAValue;
    property CODIGO: Integer read GetCODIGOValue write SetCODIGOValue;
    property FECHAALTA: DateTime read GetFECHAALTAValue write SetFECHAALTAValue;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property NIFCIF: String read GetNIFCIFValue write SetNIFCIFValue;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOTAS: String read GetNOTASValue write SetNOTASValue;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property CODIGOPOSTAL: String read GetCODIGOPOSTALValue write SetCODIGOPOSTALValue;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property TELEFONO1: String read GetTELEFONO1Value write SetTELEFONO1Value;
    property TELEFONO2: String read GetTELEFONO2Value write SetTELEFONO2Value;
    property MOVIL: String read GetMOVILValue write SetMOVILValue;
    property FAX: String read GetFAXValue write SetFAXValue;
    property CORREO1: String read GetCORREO1Value write SetCORREO1Value;
    property CORREO2: String read GetCORREO2Value write SetCORREO2Value;
    property PAGINAWEB: String read GetPAGINAWEBValue write SetPAGINAWEBValue;
    property PERSONACONTACTO: String read GetPERSONACONTACTOValue write SetPERSONACONTACTOValue;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants;

{ TCITASDataTableRules }
constructor TCITASDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TCITASDataTableRules.Destroy;
begin
  inherited;
end;

function TCITASDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_CITASID].AsInteger;
end;

procedure TCITASDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASID].AsInteger := aValue;
end;

function TCITASDataTableRules.GetPARENTIDValue: Integer;
begin
  result := DataTable.Fields[idx_CITASPARENTID].AsInteger;
end;

procedure TCITASDataTableRules.SetPARENTIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASPARENTID].AsInteger := aValue;
end;

function TCITASDataTableRules.GetSTARTValue: DateTime;
begin
  result := DataTable.Fields[idx_CITASSTART].AsDateTime;
end;

procedure TCITASDataTableRules.SetSTARTValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_CITASSTART].AsDateTime := aValue;
end;

function TCITASDataTableRules.GetTIPOValue: Integer;
begin
  result := DataTable.Fields[idx_CITASTIPO].AsInteger;
end;

procedure TCITASDataTableRules.SetTIPOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASTIPO].AsInteger := aValue;
end;

function TCITASDataTableRules.GetFINISHValue: DateTime;
begin
  result := DataTable.Fields[idx_CITASFINISH].AsDateTime;
end;

procedure TCITASDataTableRules.SetFINISHValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_CITASFINISH].AsDateTime := aValue;
end;

function TCITASDataTableRules.GetOPTIONSValue: Integer;
begin
  result := DataTable.Fields[idx_CITASOPTIONS].AsInteger;
end;

procedure TCITASDataTableRules.SetOPTIONSValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASOPTIONS].AsInteger := aValue;
end;

function TCITASDataTableRules.GetCAPTIONValue: String;
begin
  result := DataTable.Fields[idx_CITASCAPTION].AsString;
end;

procedure TCITASDataTableRules.SetCAPTIONValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASCAPTION].AsString := aValue;
end;

function TCITASDataTableRules.GetMENSAJEValue: String;
begin
  result := DataTable.Fields[idx_CITASMENSAJE].AsString;
end;

procedure TCITASDataTableRules.SetMENSAJEValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASMENSAJE].AsString := aValue;
end;

function TCITASDataTableRules.GetRECURRENCEINDEXValue: Integer;
begin
  result := DataTable.Fields[idx_CITASRECURRENCEINDEX].AsInteger;
end;

procedure TCITASDataTableRules.SetRECURRENCEINDEXValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASRECURRENCEINDEX].AsInteger := aValue;
end;

function TCITASDataTableRules.GetRESOURCEIDValue: Integer;
begin
  result := DataTable.Fields[idx_CITASRESOURCEID].AsInteger;
end;

procedure TCITASDataTableRules.SetRESOURCEIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASRESOURCEID].AsInteger := aValue;
end;

function TCITASDataTableRules.GetLOCATIONValue: String;
begin
  result := DataTable.Fields[idx_CITASLOCATION].AsString;
end;

procedure TCITASDataTableRules.SetLOCATIONValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASLOCATION].AsString := aValue;
end;

function TCITASDataTableRules.GetREMINDERValue: Integer;
begin
  result := DataTable.Fields[idx_CITASREMINDER].AsInteger;
end;

procedure TCITASDataTableRules.SetREMINDERValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASREMINDER].AsInteger := aValue;
end;

function TCITASDataTableRules.GetSTATEValue: Integer;
begin
  result := DataTable.Fields[idx_CITASSTATE].AsInteger;
end;

procedure TCITASDataTableRules.SetSTATEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASSTATE].AsInteger := aValue;
end;

function TCITASDataTableRules.GetLABELCOLORValue: Integer;
begin
  result := DataTable.Fields[idx_CITASLABELCOLOR].AsInteger;
end;

procedure TCITASDataTableRules.SetLABELCOLORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASLABELCOLOR].AsInteger := aValue;
end;

function TCITASDataTableRules.GetCODIGOCONTRATOValue: String;
begin
  result := DataTable.Fields[idx_CITASCODIGOCONTRATO].AsString;
end;

procedure TCITASDataTableRules.SetCODIGOCONTRATOValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASCODIGOCONTRATO].AsString := aValue;
end;

function TCITASDataTableRules.GetTIPOTAREAValue: String;
begin
  result := DataTable.Fields[idx_CITASTIPOTAREA].AsString;
end;

procedure TCITASDataTableRules.SetTIPOTAREAValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASTIPOTAREA].AsString := aValue;
end;

function TCITASDataTableRules.GetNOMBRECLIENTEValue: String;
begin
  result := DataTable.Fields[idx_CITASNOMBRECLIENTE].AsString;
end;

procedure TCITASDataTableRules.SetNOMBRECLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASNOMBRECLIENTE].AsString := aValue;
end;

function TCITASDataTableRules.GetPARTIDAValue: String;
begin
  result := DataTable.Fields[idx_CITASPARTIDA].AsString;
end;

procedure TCITASDataTableRules.SetPARTIDAValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASPARTIDA].AsString := aValue;
end;

function TCITASDataTableRules.GetCOMPLETADAValue: DateTime;
begin
  result := DataTable.Fields[idx_CITASCOMPLETADA].AsDateTime;
end;

procedure TCITASDataTableRules.SetCOMPLETADAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_CITASCOMPLETADA].AsDateTime := aValue;
end;

function TCITASDataTableRules.GetNOMBREPROVEEDORValue: String;
begin
  result := DataTable.Fields[idx_CITASNOMBREPROVEEDOR].AsString;
end;

procedure TCITASDataTableRules.SetNOMBREPROVEEDORValue(const aValue: String);
begin
  DataTable.Fields[idx_CITASNOMBREPROVEEDOR].AsString := aValue;
end;

function TCITASDataTableRules.GetCODIGOCOLUMNAValue: Integer;
begin
  result := DataTable.Fields[idx_CITASCODIGOCOLUMNA].AsInteger;
end;

procedure TCITASDataTableRules.SetCODIGOCOLUMNAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASCODIGOCOLUMNA].AsInteger := aValue;
end;

function TCITASDataTableRules.GetCODIGOFILAValue: Integer;
begin
  result := DataTable.Fields[idx_CITASCODIGOFILA].AsInteger;
end;

procedure TCITASDataTableRules.SetCODIGOFILAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASCODIGOFILA].AsInteger := aValue;
end;

function TCITASDataTableRules.GetEMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_CITASEMPRESA].AsInteger;
end;

procedure TCITASDataTableRules.SetEMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_CITASEMPRESA].AsInteger := aValue;
end;


{ TVENDEDORESDataTableRules }
constructor TVENDEDORESDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TVENDEDORESDataTableRules.Destroy;
begin
  inherited;
end;

function TVENDEDORESDataTableRules.GetCODIGOEMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_VENDEDORESCODIGOEMPRESA].AsInteger;
end;

procedure TVENDEDORESDataTableRules.SetCODIGOEMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_VENDEDORESCODIGOEMPRESA].AsInteger := aValue;
end;

function TVENDEDORESDataTableRules.GetCODIGOValue: Integer;
begin
  result := DataTable.Fields[idx_VENDEDORESCODIGO].AsInteger;
end;

procedure TVENDEDORESDataTableRules.SetCODIGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_VENDEDORESCODIGO].AsInteger := aValue;
end;

function TVENDEDORESDataTableRules.GetFECHAALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_VENDEDORESFECHAALTA].AsDateTime;
end;

procedure TVENDEDORESDataTableRules.SetFECHAALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_VENDEDORESFECHAALTA].AsDateTime := aValue;
end;

function TVENDEDORESDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESUSUARIO].AsString;
end;

procedure TVENDEDORESDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESUSUARIO].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetNIFCIFValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESNIFCIF].AsString;
end;

procedure TVENDEDORESDataTableRules.SetNIFCIFValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESNIFCIF].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESNOMBRE].AsString;
end;

procedure TVENDEDORESDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESNOMBRE].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetNOTASValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESNOTAS].AsString;
end;

procedure TVENDEDORESDataTableRules.SetNOTASValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESNOTAS].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESCALLE].AsString;
end;

procedure TVENDEDORESDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESCALLE].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESPROVINCIA].AsString;
end;

procedure TVENDEDORESDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESPROVINCIA].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetCODIGOPOSTALValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESCODIGOPOSTAL].AsString;
end;

procedure TVENDEDORESDataTableRules.SetCODIGOPOSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESCODIGOPOSTAL].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESPOBLACION].AsString;
end;

procedure TVENDEDORESDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESPOBLACION].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetTELEFONO1Value: String;
begin
  result := DataTable.Fields[idx_VENDEDORESTELEFONO1].AsString;
end;

procedure TVENDEDORESDataTableRules.SetTELEFONO1Value(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESTELEFONO1].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetTELEFONO2Value: String;
begin
  result := DataTable.Fields[idx_VENDEDORESTELEFONO2].AsString;
end;

procedure TVENDEDORESDataTableRules.SetTELEFONO2Value(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESTELEFONO2].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetMOVILValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESMOVIL].AsString;
end;

procedure TVENDEDORESDataTableRules.SetMOVILValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESMOVIL].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetFAXValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESFAX].AsString;
end;

procedure TVENDEDORESDataTableRules.SetFAXValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESFAX].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetCORREO1Value: String;
begin
  result := DataTable.Fields[idx_VENDEDORESCORREO1].AsString;
end;

procedure TVENDEDORESDataTableRules.SetCORREO1Value(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESCORREO1].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetCORREO2Value: String;
begin
  result := DataTable.Fields[idx_VENDEDORESCORREO2].AsString;
end;

procedure TVENDEDORESDataTableRules.SetCORREO2Value(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESCORREO2].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetPAGINAWEBValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESPAGINAWEB].AsString;
end;

procedure TVENDEDORESDataTableRules.SetPAGINAWEBValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESPAGINAWEB].AsString := aValue;
end;

function TVENDEDORESDataTableRules.GetPERSONACONTACTOValue: String;
begin
  result := DataTable.Fields[idx_VENDEDORESPERSONACONTACTO].AsString;
end;

procedure TVENDEDORESDataTableRules.SetPERSONACONTACTOValue(const aValue: String);
begin
  DataTable.Fields[idx_VENDEDORESPERSONACONTACTO].AsString := aValue;
end;


initialization
  RegisterDataTableRules(RID_CITAS, TCITASDataTableRules);
  RegisterDataTableRules(RID_VENDEDORES, TVENDEDORESDataTableRules);

end.
